export declare type ConnectionData = {
    nodeId: number;
    data: any;
};
export declare type InputConnectionData = ConnectionData & {
    outputKey: string;
};
export declare type OutputConnectionData = ConnectionData & {
    inputKey: string;
};
export declare type InputData = {
    connections: InputConnectionData[];
};
export declare type OutputData = {
    connections: OutputConnectionData[];
};
export declare type InputsData = Map<string, InputData>;
export declare type OutputsData = Map<string, OutputData>;
export declare type NodeData = {
    id: number;
    name: string;
    data: Map<string, any>;
    inputs: InputsData;
    outputs: OutputsData;
    position: [number, number];
};
export declare type NodesData = Map<string, NodeData>;
export declare type EngineData = {
    id: string;
    nodes: NodesData;
};
export declare type WorkerInputs = Map<string, any[]>;
export declare type WorkerOutputs = Map<string, any>;
