"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const io_1 = require("./io");
const errors_1 = require("./errors");
class Input extends io_1.IO {
    constructor(key, name, socket, allowMultipleConnections = false) {
        super(key, name, socket, allowMultipleConnections);
        this.control = null;
    }
    addConnection(connection) {
        if (!this.allowMultipleConnections && this.hasConnection()) {
            throw new Error(errors_1.ErrorTypes.MultipleConnectionsDisallowed);
        }
    }
    addControl(control) {
        this.control = control;
        control.parent = this;
    }
    showControl() {
        return !this.hasConnection() && this.control !== null;
    }
}
exports.Input = Input;
//# sourceMappingURL=input.js.map